## golang-github-spiffe-go-spiffe 2.1.7

=== Makefile ===
.PHONY: default all help

default: all

all: lint test

help:
	@echo "Usage: make <target>"
	@echo
	@echo "  all              - lints and tests the code"
	@echo "  lint             - lints the code"
	@echo "  test             - tests the code"
	@echo "  generate         - generate protocol buffer and gRPC stub code (default)"
	@echo "  generate-check   - ensure generated code is up to date"

# Used to force some rules to run every time
FORCE: ;

############################################################################
# OS/ARCH detection
############################################################################
os1=$(shell uname -s)
os2=
ifeq ($(os1),Darwin)
os1=darwin
os2=osx
else ifeq ($(os1),Linux)
os1=linux
os2=linux
else ifeq (,$(findstring MYSYS_NT-10-0-, $(os1)))
os1=windows
os2=windows
else
$(error unsupported OS: $(os1))
endif

arch1=$(shell uname -m)
ifeq ($(arch1),x86_64)
arch2=amd64
else ifeq ($(arch1),aarch64)
arch2=arm64
else
$(error unsupported ARCH: $(arch1))
endif

#############################################################################
# Vars
#############################################################################

build_dir := ${CURDIR}/.build/$(os1)-$(arch1)

protoc_version = 3.14.0
ifeq ($(os1),windows)
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-win64.zip
else ifeq ($(arch1),aarch64)
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-$(os2)-aarch_64.zip
else
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-$(os2)-$(arch1).zip
endif
protoc_dir = $(build_dir)/protoc/$(protoc_version)
protoc_bin = $(protoc_dir)/bin/protoc

protoc_gen_go_version := $(shell grep google.golang.org/protobuf v2/go.mod | awk '{print $$2}')
protoc_gen_go_base_dir := $(build_dir)/protoc-gen-go
protoc_gen_go_dir := $(protoc_gen_go_base_dir)/$(protoc_gen_go_version)-go$(go_version)
protoc_gen_go_bin := $(protoc_gen_go_dir)/protoc-gen-go

protoc_gen_go_grpc_version := v1.0.1
protoc_gen_go_grpc_base_dir := $(build_dir)/protoc-gen-go-grpc
protoc_gen_go_grpc_dir := $(protoc_gen_go_grpc_base_dir)/$(protoc_gen_go_grpc_version)-go$(go_version)
protoc_gen_go_grpc_bin := $(protoc_gen_go_grpc_dir)/protoc-gen-go-grpc

golangci_lint_version = v1.50.1
golangci_lint_dir = $(build_dir)/golangci_lint/$(golangci_lint_version)
golangci_lint_bin = $(golangci_lint_dir)/golangci-lint

apiprotos := \
	v2/proto/spiffe/workload/workload.proto \

#############################################################################
# Toolchain
#############################################################################

go_version_full := 1.19.12
go_version := $(go_version_full:.0=)
go_dir := $(build_dir)/go/$(go_version)

ifeq ($(os1),windows)
	go_bin_dir = $(go_dir)/go/bin
	go_url = https://storage.googleapis.com/golang/go$(go_version).$(os1)-$(arch2).zip
	exe=".exe"
else
	go_bin_dir = $(go_dir)/bin
	go_url = https://storage.googleapis.com/golang/go$(go_version).$(os1)-$(arch2).tar.gz
	exe=
endif

go_path := PATH="$(go_bin_dir):$(PATH)"

go-check:
ifeq (go$(go_version), $(shell $(go_path) go version 2>/dev/null | cut -f3 -d' '))
else ifeq ($(os1),windows)
	@echo "Installing go$(go_version)..."
	rm -rf $(dir $(go_dir))
	mkdir -p $(go_dir)
	curl -o $(go_dir)\go.zip -sSfL $(go_url)
	unzip -qq $(go_dir)\go.zip -d $(go_dir)
else
	@echo "Installing go$(go_version)..."
	$(E)rm -rf $(dir $(go_dir))
	$(E)mkdir -p $(go_dir)
	$(E)curl -sSfL $(go_url) | tar xz -C $(go_dir) --strip-components=1
endif


#############################################################################
# Linting
#############################################################################

.PHONY: lint
lint: $(golangci_lint_bin) | go-check
	@cd ./v2; PATH="$(go_bin_dir):$(PATH)" $(golangci_lint_bin) run ./...

$(golangci_lint_bin):
	@echo "Installing golangci-lint $(golangci_lint_version)..."
	@rm -rf $(dir $(golangci_lint_dir))
	@mkdir -p $(golangci_lint_dir)
	@curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(golangci_lint_dir) $(golangci_lint_version)

#############################################################################
# Tidy
#############################################################################

.PHONY: test
tidy: | go-check
	@cd ./v2; $(go_path) go mod tidy

#############################################################################
# Testing
#############################################################################

.PHONY: test
test: | go-check
	@cd ./v2; $(go_path) go test ./...

#############################################################################
# Code Generation
#############################################################################

.PHONY: generate
generate: $(apiprotos:.proto=.pb.go) $(apiprotos:.proto=_grpc.pb.go)

%_grpc.pb.go: %.proto $(protoc_bin) $(protoc_gen_go_grpc_bin) FORCE
	@echo "compiling proto $<..."
	@cd "$(dir $<)" && PATH="$(protoc_gen_go_grpc_dir):$(PATH)" \
		$(protoc_bin) \
		--go-grpc_out=. --go-grpc_opt=paths=source_relative \
		$(notdir $<)

%.pb.go: %.proto $(protoc_bin) $(protoc_gen_go_bin) FORCE
	@echo "compiling gRPC $<..."
	@cd "$(dir $<)" && PATH="$(protoc_gen_go_dir):$(PATH)" \
		$(protoc_bin) \
		--go_out=. --go_opt=paths=source_relative \
		$(notdir $<)

$(protoc_bin):
	@echo "Installing protoc $(protoc_version)..."
	@rm -rf $(dir $(protoc_dir))
	@mkdir -p $(protoc_dir)
	@curl -sSfL $(protoc_url) -o $(build_dir)/tmp.zip; unzip -q -d $(protoc_dir) $(build_dir)/tmp.zip; rm $(build_dir)/tmp.zip

$(protoc_gen_go_bin): | go-check
	@echo "Installing protoc-gen-go $(protoc_gen_go_version)..."
	@rm -rf $(protoc_gen_go_base_dir)
	@mkdir -p $(protoc_gen_go_dir)
	@GOBIN="$(protoc_gen_go_dir)" $(go_path) go install google.golang.org/protobuf/cmd/protoc-gen-go@$(protoc_gen_go_version)

$(protoc_gen_go_grpc_bin): | go-check
	@echo "Installing protoc-gen-go-grpc $(protoc_gen_go_grpc_version)..."
	@rm -rf $(protoc_gen_go_grpc_base_dir)
	@mkdir -p $(protoc_gen_go_grpc_dir)
	@GOBIN=$(protoc_gen_go_grpc_dir) $(go_path) go install google.golang.org/grpc/cmd/protoc-gen-go-grpc@$(protoc_gen_go_grpc_version)

#############################################################################
# Code Generation Checks
#############################################################################

git_dirty := $(shell git status -s)

.PHONY: generate-check
generate-check:
ifneq ($(git_dirty),)
	$(error generate-check must be invoked on a clean repository)
endif
	@$(MAKE) generate
	@$(MAKE) git-clean-check

.PHONY: git-clean-check
git-clean-check:
ifneq ($(git_dirty),)
	git diff
	@echo "Git repository is dirty!"
	@false
else
	@echo "Git repository is clean."
endif

=== debian/changelog ===
golang-github-spiffe-go-spiffe (2.1.7-2) unstable; urgency=medium

  * Team Upload
  * Upload to unstable
  * Regenerate protobuf and grpc schema using protoc-gen-go-1-3
    to match the grpc server implementation in unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 22 Jun 2024 21:27:41 -0400

golang-github-spiffe-go-spiffe (2.1.7-1) experimental; urgency=medium

  * Initial release (Closes: #1060817)

 -- Simon Josefsson <simon@josefsson.org>  Fri, 19 Jan 2024 00:13:44 +0100

=== debian/control ===
Source: golang-github-spiffe-go-spiffe
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Simon Josefsson <simon@josefsson.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-go-jose-go-jose.v3-dev (>= 3.0.3-4),
               golang-github-stretchr-testify-dev,
               golang-github-zeebo-errs-dev,
               golang-google-grpc-dev,
               golang-google-protobuf-dev,
               protoc-gen-go-1-3,
               protoc-gen-go-grpc
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe.git
Homepage: https://github.com/spiffe/go-spiffe
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/spiffe/go-spiffe

Package: golang-github-spiffe-go-spiffe-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-go-jose-go-jose.v3-dev,
         golang-github-stretchr-testify-dev,
         golang-github-zeebo-errs-dev,
         golang-google-grpc-dev,
         golang-google-protobuf-dev,
         ${misc:Depends}
Description: secure production identity framework for everyone in Go (library)
 SPIFFE, the Secure Production Identity Framework for Everyone, is a
 set of open-source standards for securely identifying software
 systems in dynamic and heterogeneous environments. Systems that adopt
 SPIFFE can easily and reliably mutually authenticate wherever they
 are running.
 .
 This library leverages the SPIFFE Workload API
 (https://github.com/spiffe/spiffe/blob/main/standards/SPIFFE_Workload_API.md),
 providing high level functionality that includes:
 .
  * Establishing mutually authenticated TLS (mTLS) between workloads
    powered by SPIFFE.
  * Obtaining and validating X509-SVIDs and JWT-SVIDs.
  * Federating trust between trust domains using SPIFFE bundles.
  * Bundle management.
 .
 See the Go Package (https://pkg.go.dev/github.com/spiffe/go-spiffe/v2)
 documentation for more information.
 .
 This package contains the library.

## golang-github-spiffe-go-spiffe 2.4.0

=== Makefile ===
--- 
+++ 
@@ -39,6 +39,8 @@
 arch2=amd64
 else ifeq ($(arch1),aarch64)
 arch2=arm64
+else ifeq ($(arch1),arm64)
+arch2=arm64
 else
 $(error unsupported ARCH: $(arch1))
 endif
@@ -70,7 +72,7 @@
 protoc_gen_go_grpc_dir := $(protoc_gen_go_grpc_base_dir)/$(protoc_gen_go_grpc_version)-go$(go_version)
 protoc_gen_go_grpc_bin := $(protoc_gen_go_grpc_dir)/protoc-gen-go-grpc
 
-golangci_lint_version = v1.50.1
+golangci_lint_version = v1.57.2
 golangci_lint_dir = $(build_dir)/golangci_lint/$(golangci_lint_version)
 golangci_lint_bin = $(golangci_lint_dir)/golangci-lint
 
@@ -81,7 +83,7 @@
 # Toolchain
 #############################################################################
 
-go_version_full := 1.19.12
+go_version_full := 1.21.8
 go_version := $(go_version_full:.0=)
 go_dir := $(build_dir)/go/$(go_version)
 
@@ -141,7 +143,7 @@
 
 .PHONY: test
 test: | go-check
-	@cd ./v2; $(go_path) go test ./...
+	@cd ./v2; $(go_path) go test -race ./...
 
 #############################################################################
 # Code Generation

=== debian/changelog ===
golang-github-spiffe-go-spiffe (2.4.0-1) unstable; urgency=medium

  * d/salsa-ci.yml: Build rdeps.  Tighten lintian/autopkgtest checks.
  * Run wrap-and-sort -satbk.
  * Use Standards-Version: 4.7.0.
  * Bump d/* copyright years.
  * New upstream version 2.4.0
  * Drop local patches (not needed for build).
  * Bump go-jose B-D from v3 to v4.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 15 Jan 2025 14:26:44 +0100

=== debian/control ===
Source: golang-github-spiffe-go-spiffe
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-go-jose-go-jose-dev,
 golang-github-stretchr-testify-dev,
 golang-github-zeebo-errs-dev,
 golang-google-grpc-dev,
 golang-google-protobuf-dev,
 protoc-gen-go-1-3,
 protoc-gen-go-grpc,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe.git
Homepage: https://github.com/spiffe/go-spiffe
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/spiffe/go-spiffe

Package: golang-github-spiffe-go-spiffe-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-go-jose-go-jose-dev,
 golang-github-stretchr-testify-dev,
 golang-github-zeebo-errs-dev,
 golang-google-grpc-dev,
 golang-google-protobuf-dev,
 ${misc:Depends},
Description: secure production identity framework for everyone in Go (library)
 SPIFFE, the Secure Production Identity Framework for Everyone, is a
 set of open-source standards for securely identifying software
 systems in dynamic and heterogeneous environments. Systems that adopt
 SPIFFE can easily and reliably mutually authenticate wherever they
 are running.
 .
 This library leverages the SPIFFE Workload API
 (https://github.com/spiffe/spiffe/blob/main/standards/SPIFFE_Workload_API.md),
 providing high level functionality that includes:
 .
  * Establishing mutually authenticated TLS (mTLS) between workloads
    powered by SPIFFE.
  * Obtaining and validating X509-SVIDs and JWT-SVIDs.
  * Federating trust between trust domains using SPIFFE bundles.
  * Bundle management.
 .
 See the Go Package (https://pkg.go.dev/github.com/spiffe/go-spiffe/v2)
 documentation for more information.
 .
 This package contains the library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_EXCLUDES := v2/examples/

# # github.com/spiffe/go-spiffe/v2/spiffegrpc/grpccredentials
# src/github.com/spiffe/go-spiffe/v2/spiffegrpc/grpccredentials/credentials_test.go:18:2: cannot find package "google.golang.org/grpc/examples/helloworld/helloworld" in any of:
# 	/usr/lib/go-1.21/src/google.golang.org/grpc/examples/helloworld/helloworld (from $GOROOT)
# 	/builds/jas/golang-github-spiffe-go-spiffe/debian/output/source_dir/_build/src/google.golang.org/grpc/examples/helloworld/helloworld (from $GOPATH)
# FAIL	github.com/spiffe/go-spiffe/v2/spiffegrpc/grpccredentials [setup failed]
#...
# spurious failure:
# === RUN   TestJWTSourceGetsUpdates
#     workload_api.go:66: WorkloadAPI address: tcp://127.0.0.1:33483
#     common_test.go:52:
#         	Error Trace:	/build/golang-github-spiffe-go-spiffe-2.1.6/_build/src/github.com/spiffe/go-spiffe/v2/workloadapi/common_test.go:52
#         	            				/build/golang-github-spiffe-go-spiffe-2.1.6/_build/src/github.com/spiffe/go-spiffe/v2/workloadapi/jwtsource_test.go:100
#         	Error:      	An error is expected but got nil.
#         	Test:       	TestJWTSourceGetsUpdates
#         	Messages:   	JWT bundle should not exist
# --- FAIL: TestJWTSourceGetsUpdates (0.01s)
#...
# weird segfault:
# === RUN   TestValidateJWTSVID/first_audience_is_valid
# panic: runtime error: invalid memory address or nil pointer dereference
# [signal SIGSEGV: segmentation violation code=0x1 addr=0x10 pc=0x706bc0]
#
# goroutine 218 [running]:
# github.com/golang/protobuf/proto.(*marshalFieldInfo).computeOneofFieldInfo.makeOneOfMarshaler.func1({0xc000152e70?}, 0xc000427320?)
# 	/<<PKGBUILDDIR>>/_build/src/github.com/golang/protobuf/proto/table_marshal.go:2373 +0xa0
# github.com/golang/protobuf/proto.(*marshalInfo).size(0xc000152e70, {0x195?})
# -- I suspect this is a bug in ancient protobuf code that won't appear in APIv2
override_dh_auto_test:
	rm -fv _build/src/github.com/spiffe/go-spiffe/v2/spiffegrpc/grpccredentials/credentials_test.go
	rm -fv _build/src/github.com/spiffe/go-spiffe/v2/workloadapi/client_test.go
	dh_auto_test $(DH_BUILD_OPTS)

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_before_dh_auto_configure:
	cp $(CURDIR)/v2/go.mod $(CURDIR)/go.mod
	cd v2/proto/spiffe/workload && \
	protoc --go-grpc_out=. --go-grpc_opt=paths=source_relative workload.proto && \
	protoc --go_out=. --go_opt=paths=source_relative workload.proto

override_dh_auto_clean:
	rm -f $(CURDIR)/go.mod
	dh_auto_clean

## golang-github-spiffe-go-spiffe 2.5.0

=== Makefile ===
--- 
+++ 
@@ -72,7 +72,7 @@
 protoc_gen_go_grpc_dir := $(protoc_gen_go_grpc_base_dir)/$(protoc_gen_go_grpc_version)-go$(go_version)
 protoc_gen_go_grpc_bin := $(protoc_gen_go_grpc_dir)/protoc-gen-go-grpc
 
-golangci_lint_version = v1.57.2
+golangci_lint_version = v1.63.4
 golangci_lint_dir = $(build_dir)/golangci_lint/$(golangci_lint_version)
 golangci_lint_bin = $(golangci_lint_dir)/golangci-lint

=== debian/changelog ===
golang-github-spiffe-go-spiffe (2.5.0-1) unstable; urgency=medium

  * New upstream version 2.5.0
  * Standards-Version: 4.7.2.
  * Use dh-sequence-golang.
  * Re-enable tests that triggered crashes in earlier toolchains.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 10 Apr 2025 08:36:44 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
- dh-golang,
+ dh-sequence-golang,
  golang-any,
  golang-github-go-jose-go-jose-dev,
  golang-github-stretchr-testify-dev,
@@ -16,7 +16,7 @@
  golang-google-protobuf-dev,
  protoc-gen-go-1-3,
  protoc-gen-go-grpc,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe.git
 Homepage: https://github.com/spiffe/go-spiffe

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_EXCLUDES := v2/examples/

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_before_dh_auto_configure:
	cp -v $(CURDIR)/v2/go.mod $(CURDIR)/go.mod
	cd v2/proto/spiffe/workload && \
	protoc --go-grpc_out=. --go-grpc_opt=paths=source_relative workload.proto && \
	protoc --go_out=. --go_opt=paths=source_relative workload.proto

execute_before_dh_auto_clean:
	rm -fv $(CURDIR)/go.mod

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/spiffe/go-spiffe/tags .*/v?(\d\S*)\.tar\.gz debian

## golang-github-spiffe-go-spiffe 2.6.0

=== debian/changelog ===
golang-github-spiffe-go-spiffe (2.6.0-1) unstable; urgency=medium

  * New upstream version
  * Run wrap-and-sort -satbk.
  * Modernize salsa-ci.
  * Use watch v5.
  * Drop Rules-Requires-Root: no.
  * Drop v2/-related workarounds.
  * Drop golang-github-zeebo-errs-dev.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 07 Oct 2025 22:05:12 +0200

golang-github-spiffe-go-spiffe (2.5.0-2) unstable; urgency=medium

  * Team upload.
  * debian/control: force building against protobuf 1.5, closes: #1110160

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 29 Jul 2025 09:48:55 -0400

=== debian/control ===
--- 
+++ 
@@ -11,16 +11,14 @@
  golang-any,
  golang-github-go-jose-go-jose-dev,
  golang-github-stretchr-testify-dev,
- golang-github-zeebo-errs-dev,
  golang-google-grpc-dev,
  golang-google-protobuf-dev,
- protoc-gen-go-1-3,
+ protoc-gen-go-1-5,
  protoc-gen-go-grpc,
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-spiffe-go-spiffe.git
 Homepage: https://github.com/spiffe/go-spiffe
-Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/spiffe/go-spiffe
 
 Package: golang-github-spiffe-go-spiffe-dev
@@ -28,10 +26,9 @@
 Multi-Arch: foreign
 Depends:
  golang-github-go-jose-go-jose-dev,
+ golang-github-golang-protobuf-1-5-dev,
  golang-github-stretchr-testify-dev,
- golang-github-zeebo-errs-dev,
  golang-google-grpc-dev,
- golang-google-protobuf-dev,
  ${misc:Depends},
 Description: secure production identity framework for everyone in Go (library)
  SPIFFE, the Secure Production Identity Framework for Everyone, is a

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_EXCLUDES := examples/

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_before_dh_auto_configure:
	cd proto/spiffe/workload && \
	protoc --go-grpc_out=. --go-grpc_opt=paths=source_relative workload.proto && \
	protoc --go_out=. --go_opt=paths=source_relative workload.proto

=== debian/watch ===
Version: 5
Template: Github
Owner: spiffe
Project: go-spiffe
